﻿using Android;
using Android.App;
using Android.Content.PM;
using Android.OS;
using AsReader251GMAUIDemo.Platforms.Droid;
using Android.Runtime;
using AndroidX.Core.App;

namespace AsReader251GMAUIDemo;

[Activity(Theme = "@style/Maui.SplashTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize | ConfigChanges.Density)]
public class MainActivity : MauiAppCompatActivity
{
    internal static MainActivity Instance { get; private set; }
    static readonly int REQUEST_CONTACTS = 1000;
    static string[] PERMISSIONS_CONTACT = {
                Manifest.Permission.WakeLock,
                Manifest.Permission.ReadExternalStorage,
                Manifest.Permission.WriteExternalStorage
        };
    protected override void OnCreate(Bundle savedInstanceState)
    {
        base.OnCreate(savedInstanceState);
        Instance = this;
        CheckPermission();
    }
    protected override void OnDestroy()
    {
        base.OnDestroy();
        AsReader251GManager manager = AsReader251GManager.sharedInstance();
        manager.Destroy();
    }
    public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
    {
        if (requestCode == REQUEST_CONTACTS)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
            else
            {
            }
        }
        else
        {
        }
    }
    private void CheckPermission()
    {
        if (Build.VERSION.SdkInt < BuildVersionCodes.M)
        {
            initAsReaderManager();
            return;
        }
        if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WriteExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WakeLock) != (int)Permission.Granted)
        {
            ActivityCompat.RequestPermissions(this, PERMISSIONS_CONTACT, REQUEST_CONTACTS);
        }
        else
        {
            initAsReaderManager();
        }
    }
    private void initAsReaderManager()
    {
        AsReader251GManager manager = AsReader251GManager.sharedInstance();
        manager.ConnectDevice();
    }
}

